# Master's Thesis
This repo contains an open source implementation of Alfredo V. Clemente's master thesis ```Decoupling deep learning and reinforcement learning for stable and efficient deep policy gradient algorithms```

# Runing locally
Requirements
* Python 3.3+
* TensorFlow 1.0+
* [Arcade-Learning-Environment](https://github.com/mgbellemare/Arcade-Learning-Environment)
* cython (pip3 package)
* scikit-image (pip3 package)
* python3-tk

# Runing locally via docker
* Follow the instructions to install [nvidia-docker](https://github.com/NVIDIA/nvidia-docker/)
* Clone the repository
* Then run the container with ```nvidia-docker run -it -v <absolute-path>/code:/root/src alfredvc/tf1-ale```

# Training the agent
For example to train an agent to play pong run ```python3 train.py -g pong -df logs/```

The agent will begin to learn after about 5 million frames, and will learn an optimal policy after about 15 million frames

# Testing the agent
To test the performance of a trained agent run ```python3 test.py -f logs/```

# Modes
To train the agent using off-policy PAAC, run with the argument ```--xentropy False```.

