class CircularBufferIndex(object):

    def __init__(self, size):
        self.size = size
        self.current_index = 0
        self.permutations = [self.__shift(list(range(size)), i) for i in range(size)]
        self.current_size = 0

    def index(self):
        return self.current_index

    def increase(self):
        self.current_index = (self.current_index + 1) % self.size
        self.current_size = min(self.size, self.current_size + 1)

    def get_all_indices(self):
        return self.permutations[self.current_index]

    def get_n_newest_indices(self, n):
        return self.get_all_indices()[n:]

    def get_n_oldest_indices(self, n):
        return self.get_all_indices()[:n]

    def __shift(self, seq, n):
        n = n % len(seq)
        return seq[n:]+seq[:n]
