import os, sys, uuid
from shutil import copyfile, rmtree

if __name__ == '__main__':
    """
    Create a gif from a set of images.
    
    Example: python3 debugging/png_to_gif.py gifs 4 4
    Takes about 1 minute to generate.
    
    The speedup term is necessary due to the fps limitation of browsers.

    """
    folder = sys.argv[1]
    speedup = int(sys.argv[2])
    delay = int(sys.argv[3])
    files = sorted(os.listdir(folder))
    sped_up_files = files[::speedup]
    temp_folder_name = uuid.uuid4().__str__()
    os.makedirs(temp_folder_name)
    for f in sped_up_files:
        copyfile(os.path.join(folder, f), os.path.join(temp_folder_name, f))
    gif__format = 'convert -delay {} -loop 0 {} {}_{}x.gif'.format(delay, os.path.join(temp_folder_name, '*.png'), folder, speedup)
    os.system(gif__format)
    rmtree(temp_folder_name)



